var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/createModal/index.tsx
var createModal_exports = {};
__export(createModal_exports, {
  default: () => createModal
});
module.exports = __toCommonJS(createModal_exports);
var import_react = __toESM(require("react"));
var import_client = require("react-dom/client");
var import_antd = require("antd");
function App({
  content,
  children = content,
  render,
  onOk,
  onCancel,
  onFailed,
  ...rest
}) {
  const formLikeRef = (0, import_react.useRef)();
  const [visible, setVisible] = (0, import_react.useState)(false);
  const [confirmLoading, setConfirmLoading] = (0, import_react.useState)(false);
  (0, import_react.useEffect)(() => {
    setVisible(true);
  }, []);
  const handleOk = async () => {
    var _a, _b;
    setConfirmLoading(true);
    try {
      const validateFields = ((_a = formLikeRef.current) == null ? void 0 : _a.validateFieldsReturnFormatValue) || ((_b = formLikeRef.current) == null ? void 0 : _b.validateFields);
      const values = await (validateFields == null ? void 0 : validateFields());
      await (onOk == null ? void 0 : onOk(values));
      setVisible(false);
    } catch (error) {
      onFailed == null ? void 0 : onFailed(error);
    } finally {
      setConfirmLoading(false);
    }
  };
  const handleCancel = (e) => {
    setVisible(false);
    onCancel == null ? void 0 : onCancel(e);
  };
  const renderPropChildren = () => {
    if (render)
      return render(formLikeRef);
    let attached = false;
    return import_react.Children.map(children, (child) => {
      if (!(0, import_react.isValidElement)(child)) {
        return child;
      }
      if (attached)
        return child;
      const childProps = {
        ...child.props,
        ref: formLikeRef
      };
      attached = true;
      return import_react.default.cloneElement(child, childProps);
    });
  };
  return /* @__PURE__ */ import_react.default.createElement(import_antd.Modal, {
    ...rest,
    confirmLoading,
    onCancel: handleCancel,
    onOk: handleOk,
    destroyOnClose: true,
    visible
  }, renderPropChildren());
}
function createModal(params) {
  setTimeout(() => {
    const div = document.createElement("div");
    document.body.appendChild(div);
    div.setAttribute("role", "Dynamically created modal");
    const root = (0, import_client.createRoot)(div);
    function destory() {
      setTimeout(() => {
        root.unmount();
        document.body.removeChild(div);
      });
    }
    root.render(/* @__PURE__ */ import_react.default.createElement(App, {
      afterClose: destory,
      ...params
    }));
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
